#ifndef __ring0_h__
#define __ring0_h__

typedef unsigned char		byte;
typedef unsigned			word;
typedef	unsigned			bit;

typedef unsigned __int8		uint8;
typedef unsigned __int16	uint16;
typedef unsigned __int32	uint32;
typedef unsigned __int64	uint64;

#define IA32CPU_TYPE 40000

#define IOCTL_IA32CPU_READ_MSR	CTL_CODE(IA32CPU_TYPE, 0x900, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_IA32CPU_WRITE_MSR	CTL_CODE(IA32CPU_TYPE, 0x901, METHOD_BUFFERED, FILE_WRITE_ACCESS)

void setup ();
void wrmsr (uint32, uint64);
uint64 rdmsr (uint32);

#endif