#pragma once
#ifndef __ia32counter_h__
#define __ia32counter_h__

#include "ia32error.h"

class ia32counter
{
protected:

	static uint32 count;

	uint32 index;

public:

	ia32counter (uint32 counters)
	{
		index = count++;

		if (index >= counters)
			throw ia32error(ia32error::err_counter_overflow);
	}
};

#endif