#include "ia32.h"
#include "p6counter.h"

void main ()
{
	p6counter c1(p6counter::L2_REQUEST, p6counter::L2_MESI);
	p6counter c2(p6counter::DCU_MEMORY_REFERENCE);

	const int c = 10000000;
	static int a[c];

	for (int ai1 = 0; ai1 < c; ai1++)
		a[ai1]++;

	SetPriorityClass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS);

	uint64 t1 = c1;
	uint64 t2 = c2;

	for (int ai2 = 0; ai2 < c; ai2++)
		a[ai2] *= 13;

	printf("L1 misses   = %I64d\nL1 accesses = %I64d\n", c1 - t1, c2 - t2);
}